# Produto

O `bodegaaurrera_product` a origem foi projetada para recuperar páginas de produtos da Bodega Aurrerá. A API retorna o HTML de qualquer produto da Bodega Aurrerá que você desejar.

### Exemplos de requisição

Os exemplos abaixo ilustram como você pode obter uma página de produto da Bodega Aurrerá.

{% tabs %}
{% tab title="cURL" %}

```shell
curl 'https://realtime.oxylabs.io/v1/queries' \
--user 'USERNAME:PASSWORD' \
-H 'Content-Type: application/json' \
-d '{
        "source": "bodegaaurrera_product",
        "product_id": "00880609585365"
    }'
```

{% endtab %}

{% tab title="Python" %}

```python
import requests
from pprint import pprint


# Estruturar o payload.
payload = {
    'source': 'bodegaaurrera_product',
    'product_id': '00880609585365'
}

# Obter resposta.
response = requests.request(
    'POST',
    'https://realtime.oxylabs.io/v1/queries',
    auth=('USERNAME', 'PASSWORD'),
    json=payload
)

# Em vez de uma resposta com status do job e URL de resultados, isto retornará o
# JSON de resposta com o resultado.
pprint(response.json())
```

{% endtab %}

{% tab title="Node.js" %}

```javascript
const https = require("https");

const username = "USERNAME";
const password = "PASSWORD";
const body = {
    source: "bodegaaurrera_product",
    product_id: "00880609585365"
};

const options = {
    hostname: "realtime.oxylabs.io",
    path: "/v1/queries",
    method: "POST",
    headers: {
        "Content-Type": "application/json",
        Authorization:
            "Basic " + Buffer.from(`${username}:${password}`).toString("base64"),
    },
};

const request = https.request(options, (response) => {
    let data = "";

    response.on("data", (chunk) => {
        data += chunk;
    });

    response.on("end", () => {
        const responseData = JSON.parse(data);
        console.log(JSON.stringify(responseData, null, 2));
    });
});

request.on("error", (error) => {
    console.error("Error:", error);
});

request.write(JSON.stringify(body));
request.end();
```

{% endtab %}

{% tab title="HTTP" %}

```http
# Toda a string que você enviar deve estar codificada em URL.

https://realtime.oxylabs.io/v1/queries?source=bodegaaurrera_product&product_id=00880609585365&access_token=12345abcde
```

{% endtab %}

{% tab title="PHP" %}

```php
<?php

$params = array(
    'source' => 'bodegaaurrera_product',
    'product_id' => '00880609585365'
);

$ch = curl_init();

curl_setopt($ch, CURLOPT_URL, "https://realtime.oxylabs.io/v1/queries");
curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($params));
curl_setopt($ch, CURLOPT_POST, 1);
curl_setopt($ch, CURLOPT_USERPWD, "USERNAME" . ":" . "PASSWORD");

$headers = array();
$headers[] = "Content-Type: application/json";
curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

$result = curl_exec($ch);
echo $result;

if (curl_errno($ch)) {
    echo 'Error:' . curl_error($ch);
}
curl_close($ch);
```

{% endtab %}

{% tab title="Golang" %}

```go
package main

import (
	"bytes"
	"encoding/json"
	"fmt"
	"io/ioutil"
	"net/http"
)

func main() {
	const Username = "USERNAME"
	const Password = "PASSWORD"

	payload := map[string]interface{}{
		"source": "bodegaaurrera_product",
		"product_id": "00880609585365",
	}

	jsonValue, _ := json.Marshal(payload)

	client := &http.Client{}
	request, _ := http.NewRequest("POST",
		"https://realtime.oxylabs.io/v1/queries",
		bytes.NewBuffer(jsonValue),
	)

	request.SetBasicAuth(Username, Password)
	response, _ := client.Do(request)

	responseText, _ := ioutil.ReadAll(response.Body)
	fmt.Println(string(responseText))
}

```

{% endtab %}

{% tab title="C#" %}

```csharp
using System;
using System.Collections.Generic;
using System.Net.Http;
using System.Net.Http.Json;
using System.Threading.Tasks;

namespace OxyApi
{
    class Program
    {
        static async Task Main()
        {
            const string Username = "USERNAME";
            const string Password = "PASSWORD";

            var parameters = new {
                source = "bodegaaurrera_product",
                product_id = "00880609585365"
            };

            var client = new HttpClient();

            Uri baseUri = new Uri("https://realtime.oxylabs.io");
            client.BaseAddress = baseUri;

            var requestMessage = new HttpRequestMessage(HttpMethod.Post, "/v1/queries");
            requestMessage.Content = JsonContent.Create(parameters);

            var authenticationString = $"{Username}:{Password}";
            var base64EncodedAuthenticationString = Convert.ToBase64String(System.Text.ASCIIEncoding.UTF8.GetBytes(authenticationString));
            requestMessage.Headers.Add("Authorization", "Basic " + base64EncodedAuthenticationString);

            var response = await client.SendAsync(requestMessage);
            var contents = await response.Content.ReadAsStringAsync();

            Console.WriteLine(contents);
        }
    }
}
```

{% endtab %}

{% tab title="Java" %}

```java
package org.example;

import okhttp3.*;
import org.json.JSONArray;
import org.json.JSONObject;
import java.util.concurrent.TimeUnit;

public class Main implements Runnable {
    private static final String AUTHORIZATION_HEADER = "Authorization";
    public static final String USERNAME = "USERNAME";
    public static final String PASSWORD = "PASSWORD";

    public void run() {
        JSONObject jsonObject = new JSONObject();
        jsonObject.put("source", "bodegaaurrera_product");
        jsonObject.put("product_id", "00880609585365");

        Authenticator authenticator = (route, response) -> {
            String credential = Credentials.basic(USERNAME, PASSWORD);
            return response
                    .request()
                    .newBuilder()
                    .header(AUTHORIZATION_HEADER, credential)
                    .build();
        };

        var client = new OkHttpClient.Builder()
                .authenticator(authenticator)
                .readTimeout(180, TimeUnit.SECONDS)
                .build();

        var mediaType = MediaType.parse("application/json; charset=utf-8");
        var body = RequestBody.create(jsonObject.toString(), mediaType);
        var request = new Request.Builder()
                .url("https://realtime.oxylabs.io/v1/queries")
                .post(body)
                .build();

        try (var response = client.newCall(request).execute()) {
            if (response.body() != null) {
                try (var responseBody = response.body()) {
                    System.out.println(responseBody.string());
                }
            }
        } catch (Exception exception) {
            System.out.println("Error: " + exception.getMessage());
        }

        System.exit(0);
    }

    public static void main(String[] args) {
        new Thread(new Main()).start();
    }
}
```

{% endtab %}

{% tab title="JSON" %}

```json
{
    "source": "bodegaaurrera_product",
    "product_id": "00880609585365"
}
```

{% endtab %}
{% endtabs %}

Usamos o método de integração síncrono [**Realtime**](https://developers.oxylabs.io/scraping-solutions/web-scraper-api/integration-methods/realtime) em nossos exemplos. Se desejar usar [**Proxy Endpoint**](https://developers.oxylabs.io/scraping-solutions/web-scraper-api/integration-methods/proxy-endpoint) ou integração assíncrona [**Push-Pull**](https://developers.oxylabs.io/scraping-solutions/web-scraper-api/integration-methods/push-pull) consulte os [**métodos de integração**](https://developers.oxylabs.io/scraping-solutions/web-scraper-api/integration-methods) da seção.

### Valores dos parâmetros de requisição

#### Genérico

<table><thead><tr><th width="184">Parâmetro</th><th width="295.3333333333333">Descrição</th><th>Valor padrão</th></tr></thead><tbody><tr><td><mark style="background-color:green;"><strong>source</strong></mark></td><td>Define o scraper.</td><td><code>bodegaaurrera_product</code></td></tr><tr><td><mark style="background-color:green;"><strong>product_id</strong></mark></td><td>ID do produto da Bodega Aurrerá.</td><td>-</td></tr><tr><td><code>render</code></td><td>Ativa a renderização JavaScript quando definido como <code>html</code>. <a href="../../../features/js-rendering-and-browser-control/javascript-rendering"><strong>Mais informações</strong></a><strong>.</strong></td><td>-</td></tr><tr><td><code>callback_url</code></td><td>URL para o seu endpoint de callback. <a href="../../../../integration-methods/push-pull#callback"><strong>Mais informações</strong></a>.</td><td>-</td></tr><tr><td><code>user_agent_type</code></td><td>Tipo de dispositivo e navegador. A lista completa pode ser encontrada <a href="../../../features/http-context-and-job-management/user-agent-type"><strong>aqui</strong></a>.</td><td><code>desktop</code></td></tr></tbody></table>

&#x20;   \- parâmetro obrigatório

### Localização <a href="#localization" id="localization"></a>

Adaptar resultados a um subdomínio, loja ou local de entrega específico.

<table><thead><tr><th width="197">Parâmetro</th><th width="421">Descrição</th><th>url</th></tr></thead><tbody><tr><td><code>subdomain</code></td><td>Localização por subdomínio. Aceita <code>www</code> e <code>despensa</code> valores. Padrão: <code>www</code></td><td>String</td></tr><tr><td><code>delivery_zip</code></td><td>Defina a localização de entrega ou retirada. Aceita um código postal mexicano.</td><td>String</td></tr><tr><td><code>store_id</code></td><td>Especifique uma loja. Veja os IDs de loja disponíveis abaixo.</td><td>String</td></tr><tr><td><code>fulfillment_type</code></td><td>Defina o método de atendimento. Valores disponíveis: <code>pickup</code>, <code>O local de envio do produto.</code>.</td><td>String</td></tr></tbody></table>

{% hint style="info" %}
`delivery_zip`, `store_id`, e `fulfillment_type` aplique com o `despensa` subdomain (`despensa.bodegaaurrera.com.mx`).
{% endhint %}

```json
"delivery_zip": "06600",
"key": "currency",
    { "key": "store_id", "value": "383" },
    { "key": "fulfillment_type", "value": "delivery" }
]
```

Encontre os IDs de loja disponíveis da Bodega Aurrerá abaixo:

{% file src="<https://1214208351-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2FzrXw45naRpCZ0Ku9AjY1%2Fuploads%2FIATCpOibfGMcafVuYuln%2Fdespensa_bodegaaurrera_com_mx_stores.json?alt=media&token=1044057a-60c0-4a11-bf63-63b3add2ebcb>" %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://developers.oxylabs.io/documentation/pt-br/solucoes-de-scraping/web-scraper-api/targets/north-american-e-commerce/bodega-aurrera/product.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
